<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['xq:userBanner:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['xq:userBanner:remove']"
        >删除</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="userBannerList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="轮播" align="center" prop="banner" >
        <template v-slot="scope">
          <image-preview :src="scope.row.banner" :height="75" :width="120"/>
        </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="enableStatus">
        <template v-slot="scope">
          <cai-dict-tag :options="enableStatusList" :value="scope.row.enableStatus"/>
        </template>
      </el-table-column>
      <el-table-column label="链接类型" align="center" prop="linkType">
        <template v-slot="scope">
          <cai-dict-tag :options="linkTypeBannerList" :value="scope.row.linkType"/>
        </template>
      </el-table-column>
      <el-table-column label="链接" align="center" prop="linkUrl" />
      <el-table-column label="排序" align="center" prop="sort" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['xq:userBanner:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['xq:userBanner:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <user-banner-add-update-dialog v-if="userBannerAddUpdateDialogVisible" ref="userBannerAddUpdateDialog" @refreshDataList="getList" />
  </div>
</template>

<script>
import { delUserBanner, listUserBanner } from '@/api/xq/userBanner'
import { enableStatusList, linkTypeBannerList } from '@/constant/statusMap'
import UserBannerAddUpdateDialog from '@/views/xq/userBanner/user-banner-add-update-dialog.vue'

export default {
  name: "UserBanner",
  components: { UserBannerAddUpdateDialog},
  data() {
    return {
      linkTypeBannerList,enableStatusList,
      userBannerAddUpdateDialogVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 我的页面推广图表格数据
      userBannerList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询我的页面推广图列表 */
    getList() {
      this.loading = true;
      listUserBanner(this.queryParams).then(response => {
        this.userBannerList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.userBannerAddUpdateDialogVisible = true
      this.$nextTick(() => {
        this.$refs.userBannerAddUpdateDialog.init()
      })
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.userBannerAddUpdateDialogVisible = true
      this.$nextTick(() => {
        this.$refs.userBannerAddUpdateDialog.init(row.id)
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除我的页面推广图编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return delUserBanner(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
  }
};
</script>
